/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "../comparator_stdheaders.h"
#include "DistanceSim.h"

namespace smartcomparator
{
	namespace simfunctions
	{
		DistanceSim::DistanceSim(Matrices::SuperMatrixPtr m, distances::DistanceFunctionPtr distfun,
					 boost::function<double(double)> scalefun)
			: SimilarityFunction(m), dst(distfun), scale(scalefun)
		{
		}

		DistanceSim::~DistanceSim(void)
		{
		}

		double DistanceSim::CountSimilarity(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			size_t , size_t , const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			return scale(dst->CountDistance(v1,v2,0,0,v1Ind,v2Ind));
		}


		double DistanceSim::MinValue() const
		{
			return 0;
		}


		double DistanceSim::CountSimilarity(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			return CountSimilarity(v1,v2,-1,-1, v1Ind, v2Ind);
		}

		double exp_scale(double x)
		{
		    return exp(-2*x);
		}
	}
}
